/*****************************************************************************
  Digital Cameras RAW file support 
  Copyright (c) 2004 by Dmitry V. Fedorov <www.dimin.net> <dima@dimin.net>

  IMPLEMENTATION
  
  Programmer: Dima V. Fedorov <mailto:dima@dimin.net> <http://www.dimin.net/>

  History:
    10/26/2004 19:00 - First creation
        
  Ver : 1
*****************************************************************************/

#ifndef DIM_MAGICK_FORMAT_H
#define DIM_MAGICK_FORMAT_H

#include <DIVFormatDefs.h>
#include <DIVFormatUtils.h>

#include <stdio.h>


DIM_INT          __stdcall dimMagickValidateFormatProc ( void *magic, DIM_UINT32 length);
TDivFormatHandle __stdcall dimMagickAquireFormatProc   ( void );
void             __stdcall dimMagickReleaseFormatProc  ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimMagickOpenImageProc      ( TDivFormatHandle *fmtHndl, TDIVIOModes io_mode);
void             __stdcall dimMagickCloseImageProc     ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimMagickGetNumPagesProc    ( TDivFormatHandle *fmtHndl );
TDivImageInfo    __stdcall dimMagickGetImageInfoProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page_num );
DIM_UINT         __stdcall dimMagickAddMetaDataProc    ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimMagickReadMetaDataProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page, int group, int tag, int type);
char*            __stdcall dimMagickReadMetaDataAsTextProc ( TDivFormatHandle *fmtHndl );
DIM_UINT         __stdcall dimMagickReadImageProc      ( TDivFormatHandle *fmtHndl, DIM_UINT page );
DIM_UINT         __stdcall dimMagickWriteImageProc     ( TDivFormatHandle *fmtHndl );

//----------------------------------------------------------------------------
// Internal Format Structs
//----------------------------------------------------------------------------

typedef struct TDimMagickParams
{
  TDivImageInfo i;
  long num_images;
} TDimMagickParams;
 

#endif // DIM_MAGICK_FORMAT_H
